<?php
$stream = getMp3StreamTitle($_GET["url"]);
echo $stream;

function getMp3StreamTitle($steam_url)
{
    $result = false;
    $icy_metaint = - 1;
    $needle = 'StreamTitle=';
    $ua = 'Winamp 2.81 Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/27.0.1453.110 Safari/537.36';
    
    $opts = array(
        'http' => array(
            'method' => 'GET',
            'header' => 'Icy-MetaData: 1',
            'user_agent' => $ua,
            'timeout' => 5
        )
    );
    
    $default = stream_context_set_default($opts);
    
    $stream = @fopen($steam_url, 'r');
    
    if (! $stream) {
        die(json_encode([
            "error" => "No icy metadata found"
        ], true));
    }
    
    if ($stream && ($meta_data = stream_get_meta_data($stream)) && isset($meta_data['wrapper_data'])) {
        $icename = "";
        $icegenre = "";
        $icebr = "";
        $iceurl = "";
        foreach ($meta_data['wrapper_data'] as $header) {
            if (strpos(strtolower($header), 'icy-name') !== false) {
                $tmp = explode(":", $header);
                if ($tmp[1]) {
                	$icename = trim($tmp[1]);
                }
            }
            if (strpos(strtolower($header), 'icy-genre') !== false) {
                $tmp = explode(":", $header);
                if ($tmp[1]) {
                    $icegenre = trim($tmp[1]);
                }
            }
            if (strpos(strtolower($header), 'icy-br') !== false) {
                $tmp = explode(":", $header);
                if ($tmp[1]) {
                    $icebr = trim($tmp[1]);
                }
            }
            if (strpos(strtolower($header), 'icy-url') !== false) {
                
                $tmp = explode(":", $header);
                if (count($tmp) == 1) {
                    $iceurl = $tmp[1];
                }
                if (count($tmp) == 2) {
                    $iceurl = $tmp[1];
                }
                if (count($tmp) == 3) {
                    $iceurl = $tmp[1] . ":" . $tmp[2];
                }
            }
            if (strpos(strtolower($header), 'icy-metaint') !== false) {
                $tmp = explode(":", $header);
                if ($tmp[1]) {
                    $icy_metaint = trim($tmp[1]);
                }
                
                // break;
            }
        }
    } else {
    	die(json_encode([
    			"error" => "No icy metadata found"
    	], true));
    }
    
    if ($icy_metaint != - 1) {
        $buffer = stream_get_contents($stream, 500, $icy_metaint);
        
        if (strpos($buffer, $needle) !== false) {
            $meta = [];
            $title = explode($needle, $buffer);
            $title = trim($title[1]);
            $result = substr($title, 1, strpos($title, ';') - 2);
            $meta = explode(" - ", $result);
        } else {
        die(json_encode([
    			"error" => "No icy metadata found"
    	], true));	
        }
    } else {
    	die(json_encode([
    			"error" => "No icy metadata found"
    	], true));
    	
    }
    
    if ($stream)
        fclose($stream);
    $artist = "";
    try {
        
        if (! empty($meta)) {
            
            if (count($meta) == 1) {
                $artist = $meta[0];
            }
            if (count($meta) == 2) {
                $artist = $meta[0] . " - " . $meta[1];
            }
            if (count($meta) == 3) {
                $artist = $meta[0] . " - " . $meta[1] . " - " . $meta[2];
            }
            if (count($meta) == 4) {
                $artist = $meta[0] . " - " . $meta[1] . " - " . $meta[2] . " - " . $meta[3];
            }
        }
        
        return json_encode([
            "icy-name" => $icename,
            "icy-genre" => $icegenre,
            "icy-br" => $icebr,
            "icy-url" => $iceurl,
            "icy-playing" => $artist,
        	"icy-by" => "PdeG ".date("Y")
        ], true);
    } catch (Exception $e) {
        die('hmm');
    }
}
/*die(json_encode([
		"error" => "No icy metadata found"
], true));*/
?>

